.include "./nios_macros.m"

.text

#.equ TEST_NUM, 0x90abcdef	/* The number to be tested */
.equ TEST_NUM, 0x90abcd3f       /* should have 6 ones in a row */

.global main
.type main, @function


main:
	movia	r7, TEST_NUM	/* Initialize <I>r7</I> with the number to be tested */
	mov	r4,r7		/* copy the number to <i>r4</i> */

string_counter:
	mov	r2, r0		/* Initialize the counter to zero */

string_counter_loop:		/* Loop until the number has no more ones */
	beq	r4,r0,end_string_counter

	srli	r5,r4,1		# calculate the number of ones by shifting the number
	and		r4,r4,r5	# by 1 and adding the result with itself
	addi	r2,r2,1		/* increment the counter: r2++  */
	br	string_counter_loop

end_string_counter:
	mov	r16,r2		/* store the result into <i>r16</i> */

end:
	br	end		/* wait here once the program has completed */

.end

